/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.java8.handson;

import com.pojo.NameId;
import java.util.Arrays;
import java.util.List;
import java.util.Random;
import java.util.concurrent.ForkJoinPool;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 *
 * @author manikandan15785
 */
public class ParallelExample {
    static List<NameId> nameIds=null;
    static final int MAX=30_00_000;
    static void buildObject(){
        Random random = new Random();
        String alpha="abcdefghijklmnopqrstuvwxyz";
        nameIds=IntStream.range(1, MAX).parallel().mapToObj(nameid->  new NameId(nameid,generateString(random, alpha, 5)))
                .collect(Collectors.toList());
    }
    public static void main(String[] args) {
        ForkJoinPool commonPool = ForkJoinPool.commonPool();
        System.out.println(commonPool.getParallelism());   // default = 3
        //-Djava.util.concurrent.ForkJoinPool.common.parallelism=5
        
        Arrays.asList("a1", "a2", "b1", "c2", "c1")
    .parallelStream()
    .filter(s -> {
        System.out.format("filter: %s [%s]\n",
            s, Thread.currentThread().getName());
        return true;
    })
    .map(s -> {
        System.out.format("map: %s [%s]\n",
            s, Thread.currentThread().getName());
        return s.toUpperCase();
    })
    .forEach(s -> System.out.format("forEach: %s [%s]\n",
        s, Thread.currentThread().getName()));

        
        
        //comparison();
    }
    public static void comparison() {
        long start,end;
        String operation="object creation";
        System.out.println("starting "+operation);
        {
         start=System.currentTimeMillis();
         buildObject();
         end=System.currentTimeMillis();
        }
        System.out.println("end of "+operation);
        System.out.println("time taken "+(end-start)+"ms");
        System.out.println("-----------------------");
        
        operation="manipulation  (java 8 parallelism)";
        System.out.println("starting "+operation);
        {
         start=System.currentTimeMillis();
         nameIds.stream().parallel().forEach((nameId) -> ParallelExample.operation(nameId) );
         end=System.currentTimeMillis();
        }
        System.out.println("end of "+operation);
        System.out.println("time taken "+(end-start)+"ms");
        System.out.println("-----------------------");
        
        operation="manipulation  (java 8 stream)";
        System.out.println("starting "+operation);
        {
         start=System.currentTimeMillis();
         nameIds.stream().forEach((nameId) -> ParallelExample.operation(nameId));
         end=System.currentTimeMillis();
        }
        System.out.println("end of "+operation);
        System.out.println("time taken "+(end-start)+"ms");
        System.out.println("-----------------------");
        
        operation="manipulation  (advance for-loop)";
        System.out.println("starting "+operation);
        {
         start=System.currentTimeMillis();
         for(NameId nameId:nameIds){
           operation(nameId);
         }
         end=System.currentTimeMillis();
        }
        System.out.println("end of "+operation);
        System.out.println("time taken "+(end-start)+"ms");
        System.out.println("-----------------------");
        
    }
    
   static  void  operation(NameId nameId){
        nameId.setId(1+ nameId.getId());
        nameId.setName(nameId.getName()+nameId.getId());
    }
    
    
    public static String generateString(Random rng, String characters, int length)
    {
        char[] text = new char[length];
        for (int i = 0; i < length; i++)
        {
            text[i] = characters.charAt(rng.nextInt(characters.length()));
        }
        return new String(text);
    }
}
